SystemOrganization addCategory: #'PersistentUnionFind-Tests'!
SystemOrganization addCategory: #PersistentUnionFind!

Object subclass: #ArrayPart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind'!

ArrayPart subclass: #Arr
	instanceVariableNames: 'array'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind'!

Arr class
	instanceVariableNames: 'array'!

!Arr commentStamp: 'fbs 12/28/2011 11:12' prior: 0!
An Arr is a wrapper for an array - really, a SequenceableCollection.!

Arr class
	instanceVariableNames: 'array'!

!Arr class methodsFor: 'instance creation' stamp: 'fbs 12/28/2011 11:45'!
wrapping: aSequenceableCollection
	^ self new wrapping: aSequenceableCollection.! !

!Arr methodsFor: 'accessing' stamp: 'fbs 12/28/2011 12:53'!
array
	^ array! !

!Arr methodsFor: 'converting' stamp: 'fbs 12/28/2011 12:38'!
asArray
	^ array copy.! !

!Arr methodsFor: 'unification' stamp: 'fbs 1/2/2012 13:50'!
elementsOfClass: aParentObject
	^ array elementsOfClass: aParentObject.! !

!Arr methodsFor: 'testing' stamp: 'fbs 12/31/2011 10:52'!
includes: anObject
	^ array includes: anObject.! !

!Arr methodsFor: 'printing' stamp: 'fbs 12/28/2011 15:59'!
printOn: aStream
	aStream
		nextPutAll: 'Arr(';
		nextPutAll: array printString;
		nextPutAll: ')'.! !

!Arr methodsFor: 'enumerating' stamp: 'fbs 1/1/2012 13:58'!
select: aUnaryBlockOrSelector
	^ array select: aUnaryBlockOrSelector.! !

!Arr methodsFor: 'private' stamp: 'fbs 12/30/2011 08:13'!
wrapping: aSequenceableCollection
	| coll |
	coll := aSequenceableCollection copy.
	array := coll isDictionary
		ifTrue: [DictionaryWithIdentity wrapping: coll]
		ifFalse: [coll].! !

!ArrayPart methodsFor: 'converting' stamp: 'fbs 12/29/2011 11:17'!
asArray
	self subclassResponsibility.! !

!ArrayPart methodsFor: 'testing' stamp: 'fbs 12/29/2011 11:16'!
isDiff
	^ false.! !

ArrayPart subclass: #Diff
	instanceVariableNames: 'index value baseArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind'!

!Diff commentStamp: 'fbs 12/29/2011 10:44' prior: 0!
A Diff is a difference record. An instance is always relative to some Arr a, and means "like a, only with this element replaced with that value."

In particular, note that baseArray is a MutableCell referencing another PersistentArray.!

!Diff class methodsFor: 'instance creation' stamp: 'fbs 12/28/2011 11:39'!
index: anInteger value: anObject in: aPersistentArray
	^ self new index: anInteger value: anObject in: aPersistentArray.! !

!Diff methodsFor: 'converting' stamp: 'fbs 12/28/2011 12:45'!
asArray
	| arr |
	arr := baseArray asArray.
	arr at: index put: value.
	^ arr.! !

!Diff methodsFor: 'accessing' stamp: 'fbs 12/29/2011 11:08'!
baseArray
	^ baseArray.! !

!Diff methodsFor: 'accessing' stamp: 'fbs 12/28/2011 12:34'!
index
	^ index.! !

!Diff methodsFor: 'private' stamp: 'fbs 12/28/2011 11:40'!
index: anInteger value: anObject in: aPersistentArray
	index := anInteger.
	value := anObject.
	baseArray := aPersistentArray.! !

!Diff methodsFor: 'testing' stamp: 'fbs 12/28/2011 11:27'!
isDiff
	^ true.! !

!Diff methodsFor: 'printing' stamp: 'fbs 12/29/2011 21:19'!
printOn: aStream
	aStream
		nextPutAll: 'Diff(';
		nextPutAll: index printString;
		nextPutAll: ', ';
		nextPutAll: value printString;
		nextPutAll: ', ';
		nextPutAll: baseArray printString;
		nextPutAll: ')'.
	! !

!Diff methodsFor: 'accessing' stamp: 'fbs 12/28/2011 12:34'!
value
	^ value.! !

Object subclass: #DictionaryWithDefault
	instanceVariableNames: 'dict default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind'!

!DictionaryWithDefault commentStamp: 'fbs 12/30/2011 23:22' prior: 0!
A DictionaryWithDefault is a Dictionary that, for unknown keys, maps those keys to some pluggable behaviour, instead of raising an exception.!

!DictionaryWithDefault class methodsFor: 'instance creation' stamp: 'fbs 12/30/2011 23:14'!
wrapping: aDictionary default: aUnaryBlockOrSelector
	^ self new wrapping: aDictionary default: aUnaryBlockOrSelector.! !

!DictionaryWithDefault methodsFor: 'accessing' stamp: 'fbs 1/1/2012 22:01'!
at: key
	^ dict at: key ifAbsentPut: [default value: key].! !

!DictionaryWithDefault methodsFor: 'accessing' stamp: 'fbs 12/30/2011 23:11'!
at: key put: value
	dict at: key put: value! !

!DictionaryWithDefault methodsFor: 'unification' stamp: 'fbs 1/2/2012 13:55'!
elementsOfClass: aParentObject
	^ dict elementsOfClass: aParentObject.! !

!DictionaryWithDefault methodsFor: 'testing' stamp: 'fbs 12/31/2011 15:39'!
includes: key
	^ dict includesKey: key.! !

!DictionaryWithDefault methodsFor: 'printing' stamp: 'fbs 12/30/2011 23:11'!
printOn: aStream
	aStream
		nextPutAll: self class name.
	dict printElementsOn: aStream.	! !

!DictionaryWithDefault methodsFor: 'private' stamp: 'fbs 12/30/2011 23:12'!
wrapping: aDictionary default: aUnaryBlockOrSelector
	dict := aDictionary.
	default := aUnaryBlockOrSelector.! !

DictionaryWithDefault subclass: #DictionaryWithIdentity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind'!

!DictionaryWithIdentity commentStamp: 'fbs 12/30/2011 23:21' prior: 0!
A DictionaryWithDefault that maps unknown keys to themselves.!

!DictionaryWithIdentity class methodsFor: 'instance creation' stamp: 'fbs 12/30/2011 08:03'!
wrapping: aDictionary
	^ self new wrapping: aDictionary.! !

!DictionaryWithIdentity methodsFor: 'private' stamp: 'fbs 12/30/2011 23:12'!
wrapping: aDictionary
	super wrapping: aDictionary default: #yourself.! !

Object subclass: #PersistentUnionFind
	instanceVariableNames: 'arrayType ranks parents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind'!

!PersistentUnionFind commentStamp: 'fbs 12/28/2011 11:07' prior: 0!
A union-find data structure maintains a _partition_ of objects in some structure. That is, it implicitly defines an equivalence relation between the nodes of some structure.

The structure provides two methods - _find_ returns the representative of some class of nodes, and _union_ merges two classes of nodes.

* ranks is an array of the ranks (sizes) of the various equivalence classes.
* parents is an array of the representative terms for each of the equivalence classes.!

!PersistentUnionFind class methodsFor: 'instance creation' stamp: 'fbs 12/29/2011 17:46'!
usingArrayType: aClass partitioning: someObjects
	^ self new usingArrayType: aClass partitioning: someObjects.! !

!PersistentUnionFind methodsFor: 'accessing' stamp: 'fbs 1/2/2012 13:56'!
elementsOfClass: aParentObject
	"Return all those objects with representative aParentObject. This returns all the elements in any particular equivalence call."
	"asSet because the representative element points to itself: it will appear twice otherwise."
	^ parents elementsOfClass: aParentObject.! !

!PersistentUnionFind methodsFor: 'accessing' stamp: 'fbs 12/29/2011 17:56'!
find: anObject
	"Return the representative element of anObject's equivalence class."
	| fAndCx |
	fAndCx := self findAux: anObject in: parents.
	parents := fAndCx first. "Path compression"
	^ fAndCx second.! !

!PersistentUnionFind methodsFor: 'private' stamp: 'fbs 12/29/2011 17:36'!
findAux: anObject in: anArray
	| representative pair |
	representative := anArray at: anObject.
	^ (representative = anObject)
		ifTrue: [{anArray. anObject.}]
		ifFalse: [ | f |
			pair := self findAux: representative in: anArray.
			f := anArray at: anObject put: representative.
			{f. representative.}]! !

!PersistentUnionFind methodsFor: 'private' stamp: 'fbs 12/29/2011 20:29'!
ranks: anArray parents: anotherArray
	ranks := anArray.
	parents := anotherArray.! !

!PersistentUnionFind methodsFor: 'accessing' stamp: 'fbs 1/1/2012 21:44'!
union: anObject with: anotherObject
	| cx cy rx ry |
	cx := self find: anObject.
	cy := self find: anotherObject.
	(cx = cy) ifTrue: [^ self].
	
	rx := ranks at: cx.
	ry := ranks at: cy.
	
	(rx > ry)
		ifTrue: [
			^ self class new
				ranks: (ranks at: cy put: ry + rx)
				parents: (parents at: cy put: cx)].
		
	^ self class new
		ranks: (ranks at: cx put: ry + rx)
		parents: (parents at: cx put: cy).! !

!PersistentUnionFind methodsFor: 'private' stamp: 'fbs 12/31/2011 15:58'!
usingArrayType: aClass partitioning: someObjects
	arrayType := aClass.
	ranks := arrayType initially: (DictionaryWithDefault wrapping: Dictionary new default: [:unused | 1]).
	parents := arrayType initially: someObjects.! !

Object subclass: #Ref
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind'!

!Ref commentStamp: 'fbs 12/29/2011 13:59' prior: 0!
I wrap some other object, acting something like a pointer. Thus, things may have an immutable pointer to me, while having my value be mutable: an immutable reference to a mutable thing.!

Ref subclass: #PersistentCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind'!

!PersistentCollection commentStamp: 'fbs 1/1/2012 14:16' prior: 0!
A PersistentCollection is a reference to an collection-like structure that permits one fast access to the _most recent version_ of the array, but also (slower) access to _previous versions_ of the array.

#at: takes an index - an integer - and returns the value associated with that index.
#at:put: takes an index and an object and associates the latter with the former. It returns a new PersistentArray (and, as a side effect, 'reroots' the backing Arr and Diff structures).

An Arr wraps a Collection. A Diff describes how to get a new array from an Arr - "like this Arr, but at index i put value v". Rerooting turns a base Arr - the original array - and a sequence of Diffs into an Arr - the current version - into a sequence of Diffs - how to recalculate a previous version - and the current version, an Arr. In other words, rerooting turns pointers into backpointers.

"Rerooting" permits O(1) access to arbitrary elements, and O(n) access to older versions of the array, where n is the number of versions.!

!PersistentCollection class methodsFor: 'instance creation' stamp: 'fbs 12/29/2011 11:38'!
initially: anArray
	^ self new wrapping: (Arr wrapping: anArray).! !

!PersistentCollection methodsFor: 'converting' stamp: 'fbs 12/29/2011 11:18'!
asArray
	^ self value asArray.! !

!PersistentCollection methodsFor: 'accessing' stamp: 'fbs 12/29/2011 21:06'!
at: anInteger
	| t |
	t := value.
	^ t isDiff
		ifFalse: [t array at: anInteger]
		ifTrue: [ | t1 |
			self reroot.
			t1 := value.
			t1 isDiff
				ifTrue: [Error signal: 'Reroot returned a Diff']
				ifFalse: [t1 array at: anInteger]]! !

!PersistentCollection methodsFor: 'accessing' stamp: 'fbs 12/30/2011 08:17'!
at: anInteger put: anObject
	| t |
	self reroot.
	((self at: anInteger) = anObject)
		ifTrue: [^ self].
	
	t := value.
	^ t isDiff
		ifTrue: [Error signal: 'Reroot returns a Diff']
		ifFalse: [ | t1 |
			t1 := value.
			t1 isDiff
				ifFalse: [| old res |
					old := t1 array at: anInteger.
					t1 array at: anInteger put: anObject.
					res := self class wrapping: t1.
					self value: (Diff index: anInteger value: old in: res).
					res]
				ifTrue: [self class wrapping:
							(Diff
								index: anInteger
								value: anObject
								in: self)]].! !

!PersistentCollection methodsFor: 'unification' stamp: 'fbs 1/2/2012 13:56'!
elementsOfClass: aParentObject
	self reroot.
	^ value elementsOfClass: aParentObject.! !

!PersistentCollection methodsFor: 'testing' stamp: 'fbs 12/31/2011 15:25'!
includes: anObject
	value isDiff
		ifTrue: [self reroot].
		
	^ value includes: anObject.! !

!PersistentCollection methodsFor: 'updating' stamp: 'fbs 12/29/2011 13:52'!
reroot
	| t t1 |
	t := value.
	t isDiff ifFalse: [^ self].
	
	t baseArray reroot.
	t1 := t baseArray value.
	t1 isDiff
		ifFalse: [ | v1 |
			v1 := t baseArray at: t index.
			t baseArray at: t index put: t value.
			self value: t1.
			t baseArray value: (Diff index: t index value: v1 in: self)]
		ifTrue: [Error signal: 'Reroot returned a Diff']! !

!PersistentCollection methodsFor: 'enumerating' stamp: 'fbs 1/1/2012 18:29'!
select: aUnaryBlockOrSelector
	self reroot.
	^ value select: aUnaryBlockOrSelector.! !

!Ref class methodsFor: 'instance creation' stamp: 'fbs 12/29/2011 11:13'!
wrapping: anObject
	^ self new wrapping: anObject.! !

!Ref methodsFor: 'printing' stamp: 'fbs 12/29/2011 11:20'!
printOn: aStream
	aStream nextPutAll: ('Ref({1})' format: {value printString})! !

!Ref methodsFor: 'accessing' stamp: 'fbs 12/29/2011 10:38'!
value
	^ value.! !

!Ref methodsFor: 'accessing' stamp: 'fbs 12/29/2011 11:13'!
value: anObject
	value := anObject.! !

!Ref methodsFor: 'private' stamp: 'fbs 12/29/2011 11:14'!
wrapping: anObject
	value := anObject.! !

!Dictionary methodsFor: '*PersistentUnionFind' stamp: 'fbs 1/2/2012 13:59'!
elementsOfClass: aParentObject
	^ ((self associations
		select: [:assoc | (assoc value == aParentObject) or: [assoc key == aParentObject]]
		thenCollect: [:assoc | {assoc key. assoc value.}])
			inject: #()
			into: [:acc :each | acc , each]) asSet asArray! !

!Dictionary methodsFor: '*PersistentUnionFind' stamp: 'fbs 1/2/2012 13:57'!
elementsOfClass:: aParentObject
	^ ((self associations
		select: [:assoc | (assoc value == aParentObject) or: [assoc key == aParentObject]]
		thenCollect: [:assoc | {assoc key. assoc value.}])
			inject: #()
			into: [:acc :each | acc , each]) asSet asArray! !

TestCase subclass: #ArrTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind-Tests'!

!ArrTest methodsFor: 'testing - converting' stamp: 'fbs 12/28/2011 12:38'!
testAsArrayReturnsArray
	self assert: #(1 2 3) equals: (Arr wrapping: #(1 2 3)) asArray.! !

TestCase subclass: #DictionaryWithDefaultTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind-Tests'!

!DictionaryWithDefaultTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 23:03'!
testAtForKnownKeyReturnsMappedValue
	| d |
	d := DictionaryWithDefault wrapping: (Dictionary newFromPairs: #(1 2)) default: #yourself.
	self assert: 2 equals: (d at: 1).! !

!DictionaryWithDefaultTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 23:05'!
testAtForUnknownKeyReturnsPluggableValue
	| d |
	d := DictionaryWithIdentity wrapping: Dictionary new default: [:key | key + 1].
	self assert: 2 equals: (d at: 1).
	self assert: 3 equals: (d at: 2).! !

!DictionaryWithDefaultTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 23:09'!
testAtPutStoresMappedValue
	| d |
	d := DictionaryWithIdentity wrapping: Dictionary new default: #yourself.
	d at: 1 put: 2.
	self assert: 2 equals: (d at: 1).! !

!DictionaryWithDefaultTest methodsFor: 'testing - instance creation' stamp: 'fbs 12/30/2011 23:09'!
testCanWrapNormalDictionary
	DictionaryWithIdentity wrapping: Dictionary new default: #yourself.! !

!DictionaryWithDefaultTest methodsFor: 'testing - testing' stamp: 'fbs 12/31/2011 15:35'!
testIncludesActsAsWrappedDictionary
	| d |
	d := DictionaryWithDefault wrapping: (Dictionary newFromPairs: #(1 2 3 4)) default: [:unused | 1].
	self assert: (d includes: 1).
	self deny: (d includes: 2).! !

TestCase subclass: #DictionaryWithIdentityTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind-Tests'!

!DictionaryWithIdentityTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 08:07'!
testAtForKnownKeyReturnsMappedValue
	| d |
	d := DictionaryWithIdentity wrapping: (Dictionary newFromPairs: #(1 2)).
	self assert: 2 equals: (d at: 1).! !

!DictionaryWithIdentityTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 08:10'!
testAtForUnknownKeyReturnsKey
	| d |
	d := DictionaryWithIdentity wrapping: Dictionary new.
	self assert: 1 equals: (d at: 1).
	self assert: 2 equals: (d at: 2).! !

!DictionaryWithIdentityTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 08:08'!
testAtPutStoresMappedValue
	| d |
	d := DictionaryWithIdentity wrapping: Dictionary new.
	d at: 1 put: 2.
	self assert: 2 equals: (d at: 1).! !

!DictionaryWithIdentityTest methodsFor: 'testing - instance creation' stamp: 'fbs 12/30/2011 08:01'!
testCanWrapNormalDictionary
	DictionaryWithIdentity wrapping: Dictionary new.! !

TestCase subclass: #DiffTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind-Tests'!

TestCase subclass: #PersistentCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind-Tests'!

!PersistentCollectionTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 08:17'!
testAtOnChangedArrayReturnsAssociatedValue
	| arr arr2 |
	arr := PersistentCollection initially: #(3 2 1).
	arr2 := arr at: 2 put: 99.
	self assert: 99 equals: (arr2 at: 2).! !

!PersistentCollectionTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 08:17'!
testAtOnNewArrayReturnsAssociatedValue
	| arr |
	arr := PersistentCollection initially: #(3 2 1).
	self assert: 2 equals: (arr at: 2).! !

!PersistentCollectionTest methodsFor: 'testing - maps' stamp: 'fbs 12/30/2011 08:19'!
testAtOnUnknownValueWorksLikeIdentity
	| map |
	map := PersistentCollection initially: Dictionary new.
	self assert: 1 equals: (map at: 1).! !

!PersistentCollectionTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 08:18'!
testAtPutLeavesWrappedArrayUnchanged
	| array persistentArray |
	array := #(3 2 1).
	persistentArray := PersistentCollection initially: array.
	persistentArray := persistentArray at: 1 put: 4.

	self assert: #(3 2 1) equals: array.! !

!PersistentCollectionTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 08:18'!
testAtPutOfSameValueApparentlyDoesNothing
	| array persistentArray |
	array := #(3 2 1).
	persistentArray := PersistentCollection initially: array.
	persistentArray := persistentArray at: 1 put: 4.
	persistentArray := persistentArray at: 1 put: 4.

	self assert: #(4 2 1) equals: persistentArray asArray.! !

!PersistentCollectionTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 08:18'!
testAtPutReturnsaPersistentArray
	| array persistentArray persistentArray2 |
	array := #(3 2 1).
	persistentArray := PersistentCollection initially: array.
	persistentArray2 := persistentArray at: 1 put: 4.
	self assert: #(4 2 1) equals: persistentArray2 asArray.! !

!PersistentCollectionTest methodsFor: 'testing - maps' stamp: 'fbs 12/30/2011 08:18'!
testAtPutWorksLikeaMap
	| map |
	map := PersistentCollection initially: Dictionary new.
	map := map at: 1 put: 4.
	self assert: 4 equals: (map at: 1).! !

!PersistentCollectionTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 08:18'!
testAtPutWorksOnImmediateReferences
	| array persistentArray |
	array := #(3 2 1).
	persistentArray := PersistentCollection initially: array.
	persistentArray := persistentArray at: 1 put: 4.
	self assert: 4 equals: (persistentArray at: 1).! !

!PersistentCollectionTest methodsFor: 'testing - accessing' stamp: 'fbs 1/1/2012 00:12'!
testAtWorksOnImmediateReferences
	| array persistentArray |
	array := #(3 2 1).
	persistentArray := PersistentCollection initially: array.
	self assert: 3 equals: (persistentArray at: 1).
	self assert: 2 equals: (persistentArray at: 2).
	self assert: 1 equals: (persistentArray at: 3).! !

!PersistentCollectionTest methodsFor: 'testing - testing' stamp: 'fbs 12/31/2011 15:26'!
testIncludesWorksLikeAnyOtherCollection
	| arr |
	arr := PersistentCollection initially: #(1 2 3).
	self deny: (arr includes: 4).
	self assert: ((arr at: 1 put: 4) includes: 4).! !

!PersistentCollectionTest methodsFor: 'testing - accessing' stamp: 'fbs 12/30/2011 08:19'!
testPersistentArraysPersist
	| arr arr2 arr3 arr4 |
	arr := PersistentCollection initially: #(1 2 3).
	arr2 := arr at: 1 put: 4.
	arr3 := arr2 at: 2 put: 5.
	arr4 := arr2 at: 3 put: 6.
	
	"A linear chain of changes."
	self assert: #(1 2 3) equals: arr asArray.
	self assert: #(4 2 3) equals: arr2 asArray.
	self assert: #(4 2 6) equals: arr4 asArray.
	
	"The alternative branch of changes."
	self assert: #(4 5 3) equals: arr3 asArray.! !

!PersistentCollectionTest methodsFor: 'testing - printing' stamp: 'fbs 12/30/2011 08:19'!
testPrintOnPrintsSensiblyForNew
	| a |
	a := PersistentCollection initially: #(1 2 3).
	self assert: 'Ref(Arr(#(1 2 3)))' equals: a printString.! !

!PersistentCollectionTest methodsFor: 'testing - printing' stamp: 'fbs 12/30/2011 08:19'!
testPrintOnPrintsSensiblyForUpdatedArrays
	| d |
	d := Diff index: 1 value: 4 in: (PersistentCollection initially: #(1 2 3)).
	self assert: 'Diff(1, 4, Ref(Arr(#(1 2 3))))' equals: d printString.! !

!PersistentCollectionTest methodsFor: 'testing - updating' stamp: 'fbs 12/30/2011 08:19'!
testRerootLeavesArraySeeminglyUnchanged
	| arr arr2 arr3 |
	arr := PersistentCollection initially: #(1 2 3).
	arr2 := arr at: 3 put: 4.
	arr3 := arr2 reroot.
	
	self assert: #(1 2 4) equals: arr3 asArray! !

!PersistentCollectionTest methodsFor: 'testing - enumerating' stamp: 'fbs 1/1/2012 13:57'!
testSelectOnEmptyCollectionDoesNothing
	| arr |
	arr := PersistentCollection initially: #().
	self assert: #() equals: (arr select: [:o | true]).
	self assert: #() equals: (arr select: [:o | false]).! !

TestCase subclass: #PersistentUnionFindTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PersistentUnionFind-Tests'!

!PersistentUnionFindTest methodsFor: 'testing - accessing' stamp: 'fbs 1/2/2012 13:59'!
testElementsOfClassUsingDictionary
	| partition p2 p3 |
	partition := PersistentUnionFind usingArrayType: PersistentCollection partitioning: (DictionaryWithIdentity wrapping: Dictionary new).
	p2 := partition union: #foo with: #bar.
	p3 := p2 union: #foo with: #baz.
	self assert: #(foo bar) equals: (p2 elementsOfClass: #foo).
	self assert: #(foo bar) equals: (p2 elementsOfClass: #bar).! !

!PersistentUnionFindTest methodsFor: 'testing - accessing' stamp: 'fbs 1/2/2012 13:59'!
testElementsOfClassWithEmptyPartition
	| partition |
	partition := PersistentUnionFind usingArrayType: PersistentCollection partitioning: #().
	self assert: #() equals: (partition elementsOfClass: 1).! !

!PersistentUnionFindTest methodsFor: 'testing - accessing' stamp: 'fbs 1/2/2012 14:00'!
testElementsOfClassWithNonEmptyPartition
	| partition p2 |
	partition := PersistentUnionFind usingArrayType: PersistentCollection partitioning: #(1 2 3 4).
	p2 := partition union: 1 with: 2.
	self assert: #(1 2) equals: (p2 elementsOfClass: 1).
	self assert: #(3) equals: (p2 elementsOfClass: 3).! !

!PersistentUnionFindTest methodsFor: 'testing - instance creation' stamp: 'fbs 12/30/2011 08:19'!
testInitialStateHasNoUnification
	| partition data |
	data := #(1 2 3 4).
	partition := PersistentUnionFind usingArrayType: PersistentCollection partitioning: data.
	self assert: data first equals: (partition find: data first).
	self assert: data second equals: (partition find: data second).
	self assert: data third equals: (partition find: data third).
	self assert: data fourth equals: (partition find: data fourth).! !

!PersistentUnionFindTest methodsFor: 'testing - union' stamp: 'fbs 12/30/2011 08:19'!
testUnionLeavesOtherEquivalenceClassesUnchanged
	| partition p2 data |
	data := #(1 2 3 4).
	partition := PersistentUnionFind usingArrayType: PersistentCollection partitioning: data.
	p2 := partition union: 1 with: 3.

	self assert: 3 equals: (partition find: 3).
	self assert: 4 equals: (partition find: 4).! !

!PersistentUnionFindTest methodsFor: 'testing - union' stamp: 'fbs 12/30/2011 08:19'!
testUnionMergesTwoEquivalenceClasses
	| partition p2 data |
	data := #(1 2 3 4).
	partition := PersistentUnionFind usingArrayType: PersistentCollection partitioning: data.

	p2 := partition union: 1 with: 3.
	self assert: (p2 find: 1) equals: (p2 find: 3).! !

!PersistentUnionFindTest methodsFor: 'testing - map unions' stamp: 'fbs 12/31/2011 15:59'!
testUnionOfUnknownKeysMergesClasses
	| partition p2 |
	partition := PersistentUnionFind usingArrayType: PersistentCollection partitioning: (DictionaryWithIdentity wrapping: Dictionary new).
	p2 := partition union: 1 with: 3.

	self deny: (partition find: 1) = (partition find: 3).
	self assert: (p2 find: 1) equals: (p2 find: 3).
	self assert: 4 equals: (p2 find: 4).! !

!PersistentUnionFindTest methodsFor: 'testing - union' stamp: 'fbs 12/30/2011 08:19'!
testUnionsDontAffectPreviousVersions
	| partition p2 p3 p4 data |
	data := #(1 2 3 4).
	partition := PersistentUnionFind usingArrayType: PersistentCollection partitioning: data.
	p2 := partition union: 1 with: 3.
	p3 := partition union: 2 with: 4.
	p4 := partition union: 1 with: 2.
	self assert: (p2 find: 1) equals: (p2 find: 3).
	self deny: (p2 find: 1) = (p2 find: 2).! !

!SequenceableCollection methodsFor: '*PersistentUnionFind' stamp: 'fbs 1/2/2012 14:05'!
elementsOfClass: aParentObject
	"Given a relation from integers to integers, and given some integer aParentObject, what numbers (including aParentObject) make up this equivalence class?"
	| fakeDict |
	"An array is a dictionary mapping indices to objects. Dictionary already implements this, so to spare programmer cycles, use Dictionary's implementation."
	fakeDict := Dictionary new.
	self doWithIndex: [:element :index | fakeDict at: index put: element].
	^ fakeDict elementsOfClass: aParentObject.! !
